/************************************************************/
/* wiczenie 3 - sterowanie portami w trybie wejciowym     */
/* Obsuga przyciskw doczonych do portw mikrokontrolera */
/* Licznik rewersyjny nacini klawiszy                    */
/* J.D.  '2003                                              */
/************************************************************/
#include <io.h>
#include <interrupt.h>
#include <signal.h>

#define tau0 247;	//staa czasowa timera0
#define vliczt0 113;	//staa wpisywana do licznika wej do
	//do przerwania timera0

//********************  zmienne globalne  *******************
unsigned char liczt0;	//Licznik wej do przerwania timera0.
	//Klawisz jest badany, gdy liczt0=0
unsigned char licznik;	//Licznik rewersyjny, ktrego stan jest
	//wywietlany na linijce LED-w

void czekaj(unsigned long zt) //procedura wytracania czasu
{		
 unsigned char zt1;
 for(;zt>0;zt--)
 {
  for(zt1=255;zt1!=0;zt1--);
 }
}

SIGNAL (SIG_OVERFLOW0)	//obsuga przerwania 
	//od przepenienia timera0
{
 TCNT0=tau0;           //odwie sta czasowa w TCNT0
 PORTD^=1<<PD6;	//zmie stan wy generatora 434Hz
 if(--liczt0==0)	//czy ju czyta klawisze?
 { 	//tak
  if(bit_is_clear(PIND,PD1))	//czytaj SW4 - <->
  {
   licznik--;
  }
  else
  {
   if(bit_is_clear(PIND,PD0)) 	//czytaj SW1 - <+>
   {
    licznik++; 
   }
  }
  PORTB=~licznik;	//wywietl stan licznika na LED-ach
	//negacja jest potrzebna, gdy LEDY s
	//zapalane niskim stanem
  liczt0=vliczt0;	//odwie stan liczt0
 }
}

int main(void)
{
 liczt0=vliczt0;

 DDRD=0x60;	//PD0-PD4 jako wejciowy, PD5-PD6 - wy
 PORTD=0xff;	//z podciganiem
 DDRB=0xff;	//PORTB - wy
 PORTB=0xff;	//z podciganiem
 TIMSK=1<<TOIE0;	//zezwolenie na przerwania od TC0
 TCNT0=tau0;           //wpisz sta czasowa do TCNT0
 TCCR0=5;              //preskaler XTAL/1024, 
	//kwant mierzonego czasu = 128<m>s
 sei();                //odblokuj globalne przerwania
  
 while(1)
 {
  PORTD^=0x20;	//generator 
  czekaj(10000L);
 }
}

