/****************************************************************/
/* wiczenie 6 - Zastosowanie komparatora analogowego do budowy */
/*               przetwornika analogowo-cyfrowego.              */
/*               Wyzwalanie funkcji przechwytywania timera1     */
/*               za pomoc komparatora.                         */
/*               Przerwanie od przechwytywania.                 */
/*               Obsuga wewntrznej pamici EEPROM.            */
/* J.D. '2003                                                   */
/****************************************************************/
#include <io.h>
#include <interrupt.h>
#include <signal.h>
#include <eeprom.h>

//********************  zmienne globalne  *******************
unsigned char liczt0;
volatile unsigned char pomiar;    //flaga dokonania pomiaru
union{
      unsigned int wspkal;        //wspczynnik kalibracji
      unsigned char wspkalb[2];
      }uwspkal;

void czekaj(unsigned long zt) //procedura wytracania czasu
{
 #define tau 10.38
 unsigned char zt1;
 for(;zt>0;zt--)
 {
  for(zt1=255;zt1!=0;zt1--);
 }
}

SIGNAL (SIG_INPUT_CAPTURE1)  //obsuga przerwania od przechwycenia
{
 union{
       unsigned int czas;
       unsigned char czasb[2];
      }uczas;
 unsigned char czas8;

 uczas.czasb[0]=ICR1L;       //zatrzanij rejestry przechwytywania
 uczas.czasb[1]=ICR1H;
 czas8=~((uczas.czas/uwspkal.wspkal)<<2);   //normalizacja wyniku 
                   //do postaci 6-bitowej liczby binarnej przesunitej o 2 bity 
                   //w lewo (PORTB1 i 0 s wykorzystywane przez komparator
                   //analogowy)
 PORTB=(PORTB&0x03)|czas8;   //wywietl wynik na LEDach
 pomiar=1;                   //pomiar dokonany (zapal flag)
 sbi(PORTD,4);               //zacznij rozadowywa kondensator pomiarowy
}

int main(void)
{
 DDRD=0x13;       //PORTD we oprcz PD4, PD1 i PD0 - wy
 PORTD=0xff;      //z podciganiem
 PORTB=0x01;      //PB0 z podciganiem
 DDRB=0xfc;       //PORTB7-2 - wy, PORTB1-0 - we
 TCCR1A=0;        //funkcje porwnania i PWM wyczone
 TCCR1B=0x41;     //preskaler XTAL/1 dla TC1, przechwytywanie na
                  //narastajcym zboczu
 TIMSK=0x08;      //zezwolenie na przerwania od przechwytywania
 ACSR=1<<ACIC;    //zezwolenie na wyzwalanie przechwytywania komparatorem
 czekaj(10*tau);
 TIFR=0xff;       //kasuj przerwania od timerw
 
 if(bit_is_clear(PIND,1))
 {             //wcinity SW4 - kalibracja
  do
  {
   cbi(PORTD,4);        //aduj kondensator pomiarowy
   TCNT1H=0;      //zeruj licznik 1 pomiar czasu adowania
   TCNT1L=0;
   sbi(TIFR,ICF1);
   while(bit_is_clear(TIFR,ICF1));    //czekaj a napicie mierzone zrwna si z napiciem
                                      //wejciowym
   uwspkal.wspkal=(ICR1L+256*ICR1H);
   sbi(PORTD,4);
   czekaj(1*tau);          //opnienie zwizane z czstotliwoci odwieania
  }while(bit_is_set(PIND,0));
  uwspkal.wspkal/=64;
  eeprom_wb(1,uwspkal.wspkalb[0]);  //zapisz wspczynnik kalibracji 
  eeprom_wb(2,uwspkal.wspkalb[1]);  //do pamici EEPROM
  sbi(TIFR,ICF1);
 }
 else
 {
  uwspkal.wspkal=eeprom_rw(1);  //odczytaj wspczynnik kalibracji z EEPROM-u
 }
 sei();                //odblokuj globalne przerwania
 while(1)              //gwna ptla pomiarowa
 {
  cbi(PORTD,4);        //aduj kondensator pomiarowy
  TCNT1H=0;            //zeruj licznik 1 - pomiar czasu adowania
  TCNT1L=0;
  pomiar=0;
  while(pomiar==0);    //czekaj a napicie mierzone zrwna si z napiciem
                       //na kondensatorze pomiarowym
  czekaj(23*tau);      //opnienie zwizane z czstotliwoci odwieania
                       //wskanika LED
 }
}

